Subject: RE: R: I: R: RFC3280: doubt on the use of UTF8String inencodingRDNs

From: "Stefan Santesson" <[email-masked]>
Date: Fri, 14 May 2004 10:03:24 +0100

The whole encoding rollover certificate issue seems to be in error and
should probably be deprecated.

Here is the reason:

Either you regard names of different encoding a name match or you don't.

X.509 matching rules for attributes caseIgnoreSyntax suggest that names
in different encoding are a match if they can be concluded to express
the same name.

RFC 3280 say that this is OK to implement, but you are allowed to
disregard this and treat names of different encoding as no match

So.... If this IS accepted as a name match, then you don't need the
rollover cert. It has no function since the path now works without it.

The paradox is then the following: 
If we fix name matching in RFC 3280, then there IS NO use of the
encoding rollover cert any more (path works without it). If we on the
other hand DON't fix this, then this certificate will neither be a self
issued certificate by definition and thus it will in some cases break
path validation.

Stefan Santesson
Program Manager, Windows Security

> -----Original Message-----
> From: [email-masked]
[mailto:[email-masked]]
> On Behalf Of Wen-Cheng Wang
> Sent: den 14 maj 2004 09:21
> To: Tom Gindin
> Cc: Santoni Adriano; [email-masked]; Stephen Kent;
> [email-masked]; Stefan Santesson; Steve Hanna
> Subject: Re: R: I: R: RFC3280: doubt on the use of UTF8String
> inencodingRDNs
> 
> 
> Tom,
> 
> >
> >         The bottom line of the statements you have quoted is that
some
> > fully RFC 3280-compliant RP implementations will treat all rollover
> > certificates as self-issued, some will treat no rollover
certificates as
> > self-issued, and some will treat many rollover certificates as self-
> issued
> > but some as not.  Thus, whether a given rollover certificate is
deemed
> to
> > be self-issued by a compliant RP is implementation dependent -
probably
> a
> > worse situation than "rollover certificates are not interpreted as
> > self-issued".
> Yes, the current situation is that some RP implementations will treat
> name rollover certificates (if any) as self-issued but some will not.
> The root cause of inconsistency on interpreting self-issued
certificates
> among different implementations is the deficiency of name matching
> rules in RFC 3280 and the X.509 standard. There can be a debate
> on whether name rollover certificates should be interpreted as
> self-issued or not. However, the current situation is the current
> situation. The situation will not change unless the deficiency in
> RFC 3280 and the X.509 standard is mended and hopefully
> all RP implementations will migrate to  a consistent way of
> interpreting self-issued certificates. The point is that even if we
> finally
> agree that  "name rollover certificates should not interpreted as
> self-issued", we still need to revise or amend  RFC 3280 and the
> X.509 standard to make it clear.
> 
> >         IMHO, it would really help if we had a list of CA's who
encode
> > their current DN's using BMPString with characters in the surrogate
> range,
> > and whether they are compliant to UTF-16 or not, and a list of CA's
who
> > encode their current DN's using T61String.  Most other character
> > conversions under the ASN.1 standard are simple algorithms.
> >
> That might be an interesting investigation, but I do not think it will
> help for resolving the inconsistency on interpreting self-issued
> certificates. As I said above, the root cause is the deficiency of
> name matching rules. Paying more attention to mend the deficiency
> might be more helpful. If we have name matching rules that can take
> care of name string in different character sets and/or in different
> encoding, it will not only resolve the inconsistency on interpreting
> self-issued certificates but also will reduce the needs of issuing
> name rollover certificates.
> 
> Wen-Cheng Wang

---

From: "Wen-Cheng Wang" <[email-masked]>
Date: Fri, 14 May 2004 20:09:01 +0800

I agree that if all RP implementations adopt X.500-like name matching
rules, then there is no need to issue name encoding rollover certificates.

Even so, we still need to clarify whether a certificate with same issuer
and subject names but in different encoding should be interpreted
as self-issued, because there is no way to prohibit CAs from issuing
such certificates (e.g., CA1-CA1-p-u-cert I mentioned in my recent post).

Wen-Cheng Wang